(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('TongxunluController', function($scope, $state, ionicMaterialInk, $ionicPopup, gerenService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 20;
      $scope.condition = '';

      $scope.loadData = () => {
        gerenService.queryPhonebook(
          $scope.pageNumber, // pageNumber
          $scope.pageSize, // pageSize
          $scope.condition, // condition
        )
        .then(function(res){
          // console.log(res);
          if (res.data.code === 1) {
            $scope.dataList = $scope.dataList.concat(res.data.data);
            $scope.pageTotal = res.data.pageTotal;
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.showLoading();
      $scope.doRefresh = function () {
				$scope.pageNumber = 1
        $scope.dataList = [];
        $scope.fenzhuList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      $scope.$on('refresh', function(ev) {
        $scope.doRefresh();
      });

      $(function() {
        // $('.tab-nav.tabs > a')[1].style.display = 'block';
        // $('.tab-nav.tabs > a')[2].style.display = 'none';
        // $('.tab-nav.tabs > a')[3].style.display = 'none';
        // $('.tab-nav.tabs > a')[4].style.display = 'none';
        // $('.tab-nav.tabs > a')[5].style.display = 'none';
        // $('#xiaoxiCount')[0].style.display = 'none';
      });
		});
})();

