/* global angular, document, window, LOGIN_PASSWORD */
(function(){
	'use strict';

	angular.module('starter.controllers')

		.controller('WodeController', function($rootScope, $scope, $ionicPopup, gerenService, userService, multimediaService) {
      // Set Header
      $scope.$parent.showHeader();
      // $scope.$parent.hideTabBar();
      $scope.showTabBar();

      $scope.role = userService.getRole();

      $scope.isDashTabBar = function() {
        return false;
      }

      gerenService.queryXingdongli()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.xingdongli = res.data.data;
        } else{
          
        }
      },
      function(err){
      });

      $scope.loadData = () => {
        gerenService.queryUserMsg()
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data[0];
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.comfirmLogout = () => {
        let myPopup = $ionicPopup.show({
          title: '<div class="table-line"><span class="popup-title">退出登录</span></div>',
          subTitle: '<div><span class="popup-content">是否确认退出?</span></div>',
          scope: $scope,
          buttons: [
            {
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
            },
            {
              text: '确认',
              type: 'button-right background-red',
              onTap: function(e) {
                return 1;
              }
            },
          ]
        })
        .then(function(res) {
          if (res == 1) {
            $scope.showLoading();
            $scope.logout();
          }
        });
      }

      $scope.showLoading();

      $scope.loadData();

      $scope.avatar = 'img/no-avatar.jpg';
      multimediaService.getImageList(userService.getUserId(), 'tenterprise_users')
      .then(function(res){
        if (res.data.code == 1 && res.data.data.length > 0) {
          $scope.avatar = res.data.data[res.data.data.length - 1].url;
        }
      })

      $(function() {
        // $('.tab-nav.tabs > a')[1].style.display = 'block';
        // $('.tab-nav.tabs > a')[2].style.display = 'none';
        // $('.tab-nav.tabs > a')[3].style.display = 'none';
        // $('.tab-nav.tabs > a')[4].style.display = 'none';
        // $('.tab-nav.tabs > a')[5].style.display = 'none';
        // $('#xiaoxiCount')[0].style.display = 'none';
      });
		})

	;
})();

