(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('ZhanghuBianjiController', function($scope, $state, ionicMaterialInk, $ionicPopup, gerenService) {
      const enterpriseUserId = $state.params.enterpriseuserid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.loadData = () => {
        gerenService.queryUserList()
        .then(function(res){
          if (res.data.code === 1) {
            $scope.dataList = res.data.data;
            let tagTxt = ''
            $scope.dataList.forEach(data => {
              if (data.tenterprise_userid == enterpriseUserId) {
                $scope.data = data;
                data.subusers.forEach(tag => {
                  $scope.dataList.forEach(subuser => {
                    if (subuser.tenterprise_userid == tag.tenterprise_userid) {
                      if (subuser.fname)
                        tagTxt = `${tagTxt}, ${subuser.fname}` 
                      $("#tag-selector").val(tagTxt.substr(1))
                      subuser.selected = true
                    }
                  })
                })
                $scope.data.fphonenumber = $scope.data.fphonenumber ? Number($scope.data.fphonenumber) : null;
              }
            });
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.showLoading();

      gerenService.selectStore()
      .then(function(res){
        $scope.stores = res.data.data;
      },
      function(err){
      });

      $scope.loadData();

      $scope.modify = function() {
        // if (!checkPhone($scope.data.fphonenumber)){
        //   $scope.showToast({title: '手机号码有误，请重填'});
        //   return;
        // }

        $scope.showLoading();

        $scope.data.subusers = $scope.tag
        gerenService.updateUserMsg(enterpriseUserId, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showStoreSelectPanel = function() {
        $scope.selectModel = $scope.stores;
        $scope.selectKeyField = "tstoreid";
        $scope.selectValueField = "fstorename";
        $scope.selectModelName = "tstoreid";
        $scope.selected = $scope.data.tstoreid;

        $scope.showSelectPanel();
      }

      $(function() {
        // $('.tab-nav.tabs > a')[1].style.display = 'block';
        // $('.tab-nav.tabs > a')[2].style.display = 'none';
        // $('.tab-nav.tabs > a')[3].style.display = 'none';
        // $('.tab-nav.tabs > a')[4].style.display = 'none';
        // $('.tab-nav.tabs > a')[5].style.display = 'none';
        // $('#xiaoxiCount')[0].style.display = 'none';
      });

      $scope.isShowTags = false
      
      $scope.showTags = function() {
        $('#tagSelector').css('height', '200px');
        $scope.isShowTags = true;
      }

      $scope.hideTags = function() {
        $scope.isShowTags = false;
      }

      $scope.tag = []
      $scope.selectTag = function(tag) {
        tag.selected = tag.selected == true ? false : true

        $scope.tag = []

        let tagTxt = ''
        for (let i in $scope.dataList) {
          if ($scope.dataList[i].selected == true)
          {
            if ($scope.dataList[i].fname)
              tagTxt = `${tagTxt}, ${$scope.dataList[i].fname}`
            $scope.tag.push({
              fsubid: $scope.dataList[i].tenterprise_userid
            })
          }
        }

        $("#tag-selector").val(tagTxt.substr(1))
      }
		});
})();

