/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('ZhanghuLiebiaoController', function($scope, gerenService, $ionicPopup, multimediaService)
    {
      $scope.dataList = [];
      $scope.hideTabBar();

      $scope.loadData = () => {
        gerenService.queryUserList()
        .then(function(res){
          if (res.data.code === 1) {
            $scope.dataList = res.data.data;
            $scope.dataList.forEach(element => {
              element['avatar'] = 'img/no-avatar.jpg';
              multimediaService.getImageList(element.tenterprise_userid, 'tenterprise_users')
              .then(function(rr){
                if (rr.data.code == 1 && rr.data.data.length > 0) {
                  element['avatar'] = rr.data.data[rr.data.data.length - 1].url;
                }
              })
            });
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.showLoading();
      $scope.loadData();

      $(function() {
        // $('.tab-nav.tabs > a')[1].style.display = 'block';
        // $('.tab-nav.tabs > a')[2].style.display = 'none';
        // $('.tab-nav.tabs > a')[3].style.display = 'none';
        // $('.tab-nav.tabs > a')[4].style.display = 'none';
        // $('.tab-nav.tabs > a')[5].style.display = 'none';
        // $('#xiaoxiCount')[0].style.display = 'none';
      });
    })
})();
