(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('GongzuoJieguoPingdingController', function($rootScope, $scope, $ionicPopup, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      $scope.loadData = () => {
        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date());
          $scope.setFenxiPeriodEnd(new Date());
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年' + ("0" + ($scope.fenxiPeriodStart.getMonth() + 1)).slice(-2) + '月');
        }

        qiyeShujuService.businessTripGrade($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.businessTripGradeList = $scope.businessTripGradeList.concat(res.data.data);
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
          $scope.$broadcast('scroll.refreshComplete');
        },
        function(err) {
          $scope.hideLoading();
          $scope.$broadcast('scroll.refreshComplete');
        });
      }

      $scope.doRefresh = function () {
        $scope.showLoading();
        $scope.businessTripGradeList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.$on('refresh', function(ev) {
        $scope.doRefresh();
      });
    });
})();

