(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('GongzuoShujuShouyeController', function($rootScope, $scope, $location, $anchorScroll, $ionicPopup, qiyeShujuService, $timeout) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.scrollTo = function(target){
        $location.hash(target); // set the location hash
        $anchorScroll();
      };

      $scope.selectTab = function(idx){
        $scope.navIndex = idx;
        $scope.$broadcast('scroll.refreshComplete');
      }

      $scope.showLoading();

      qiyeShujuService.businessTripGrade()
      .then(function(res) {
        if (res.data.code === 1) {
          $scope.businessTripGradeList = res.data.data.slice(0, 10);
        } else {
          
        }
      },
      function(err) {
      });

      qiyeShujuService.businessTripGetKnowledge()
      .then(function(res) {
        if (res.data.code === 1) {
          $scope.businessTripGetKnowledgeList = res.data.data.slice(0, 10);
        } else {
          
        }

        $scope.hideLoading();
      },
      function(err) {
        $scope.hideLoading();
      });

      $scope.setFavButtonInvisible = () => {
        $timeout.cancel($scope.timer);
        $scope.timer = $timeout(function() {
          $scope.show1 = false;
          $scope.show2 = false;
        }, 1500);
      }

      $('.shuju-topmenu-panel').css('height', '63px');
      $('ion-content.gongzuoshuju').css("top", "107px");

    });
})();

