/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('TibaoJianguanController', function($scope, tibaoJianguanService, $ionicPopup)
    {
      $scope.dataList = [];
			$scope.hideTabBar();
			
			$scope.todayDate = getDateString(new Date())

			tibaoJianguanService.queryAgentLastInputDays()
			.then(function(res){
				if (res.data.code === 1) {
					$scope.dataList = res.data.data;
				} else{
					$ionicPopup.alert({
						title: res.data.msg
					});
				}
				$scope.refreshComplete();
			},
			function(err){
				$scope.refreshComplete();
			});
    })
})();
