(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('KechengXiangqingController', function($scope, $rootScope, $ionicPopup, $stateParams, sucaiService, multimediaService, userService) {
      $scope.archivesId = $stateParams.archivesid;

      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
      $rootScope.isDownloading = -1

      $scope.loadData = () => {
        sucaiService.queryArchivesMain($scope.archivesId, '_sc')
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data[0];
            $scope.data.fmycollection = $scope.data.fmycollection ? Number($scope.data.fmycollection) : 0;
            // $scope.data = $scope.setDefaults($scope.data);
            if ($scope.data.fmycollection == '暂无') {
              $scope.data.fmycollection = 0;
            } else {
              $scope.data.fmycollection = 1;
            }
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.showLoading();

      $scope.loadData();

      $scope.avatar = 'img/no-avatar.jpg';
      multimediaService.getImageList(userService.getUserId(), 'tenterprise_users')
      .then(function(res){
        if (res.data.code == 1 && res.data.data.length > 0) {
          $scope.avatar = res.data.data[res.data.data.length - 1].url;
        }
      })
      
      multimediaService.getImageList($scope.archivesId, 'tarchives_sc')
      .then(function(res) {
        $scope.imageData = res.data.data;
      })

      $scope.changeCollectionStatus = function() {
        $scope.showLoading();
        sucaiService.archivesCollection($scope.archivesId, 1 - $scope.data.fiscollection, '_sc')
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data.fiscollection = 1 - $scope.data.fiscollection;
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

		});
})();

