(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('LaokehuGenjinController', function($rootScope, $scope, $ionicPopup, userService, fenxiService, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      $scope.pageNumber = 1;
      $scope.pageSize = 100;

      $scope.loadData = () => {
        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date());
          $scope.setFenxiPeriodEnd(new Date());
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年' + ("0" + ($scope.fenxiPeriodStart.getMonth() + 1)).slice(-2) + '月');
        }
        
        fenxiService.queryOldCustomerBless()
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.oldCustomerBlessList = res.data.data;
            $scope.tips['laokehushengritixing']  = res.data.tips;
            $scope.showTip['laokehushengritixing'] = false;
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
        },
        function(err) {
        });

        fenxiService.queryOldCustomerCycle()
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.oldCustomerCycleList = res.data.data;
            $scope.tips['laokehugoumaizhounian']  = res.data.tips;
            $scope.showTip['laokehugoumaizhounian'] = false;
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideLoading();
        });
      }

      $scope.doRefresh = function () {
        $scope.showLoading();
        $scope.pageNumber = 1
        $scope.totalAmount = 0;
        $scope.oldCustomerBlessList = [];
        $scope.oldCustomerCycleList = [];
        $scope.tips = [];
        $scope.showTip = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      $scope.$on('refresh', function(ev) {
        $scope.doRefresh();
      });
    });
})();

