(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('KehuDanganFenxiShouyeController', function($rootScope, $scope, $location, $anchorScroll, $ionicPopup, userService, fenxiService, qiyeShujuService, $timeout) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.scrollTo = function(target){
        $location.hash(target); // set the location hash
        $anchorScroll();
      };

      $scope.selectTab = function(idx){
        $scope.navIndex = idx;
        $scope.$broadcast('scroll.refreshComplete');
      }

      $scope.showLoading();

      setTimeout(function() {
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryOldCustomer(1, 10)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.tips1 = res.data.tips;
            $scope.oldCustomerList = res.data.data;
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
        },
        function(err) {
        });

        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryNewCustomer(1, 10)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.tips2 = res.data.tips;
            $scope.newCustomerList = res.data.data;
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
        },
        function(err) {
        });

        if (userService.getRole() == '经销商') {
          fenxiService.queryOldCustomerBless()
          .then(function(res) {
            if (res.data.code === 1) {
              $scope.oldCustomerBlessList = res.data.data;
              $scope.tips3_1 = res.data.tips;
              $scope.showTip3_1 = false;
            } else {
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
          },
          function(err) {
          });

          fenxiService.queryOldCustomerCycle()
          .then(function(res) {
            if (res.data.code === 1) {
              $scope.oldCustomerCycleList = res.data.data;
              $scope.tips3_2 = res.data.tips;
              $scope.showTip3_2 = false;
            } else {
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }

            $scope.hideLoading();
          },
          function(err) {
            $scope.hideLoading();
          });

          fenxiService.queryNewCustomerTrack()
          .then(function(res) {
            if (res.data.code === 1) {
              $scope.newCustomerTrackList = res.data.data;
              $scope.tips4 = res.data.tips;
            } else {
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }

            $scope.hideLoading();
          },
          function(err) {
            $scope.hideLoading();
          });
        }
      }, 500);

      $scope.setFavButtonInvisible = () => {
        $timeout.cancel($scope.timer);
        $scope.timer = $timeout(function() {
          $scope.show1 = false;
          $scope.show2 = false;
          $scope.show3 = false;
          $scope.show4 = false;
        }, 1500);
      }

      $(function() {
        $('ion-content').scroll(function(ev) {
          if ($('div.shuju-topmenu-panel').length) {
            if ($('ion-content').scrollTop() >= 20 ||
                (ev.target.scrollTop && ev.target.scrollTop >= 20) ||
                (ev.originalEvent.detail && ev.originalEvent.detail.scrollTop >= 20)) {
              $('div.tabs-top div.shuju-topmenu-panel').addClass('fixed-header');
              $('ion-content.xiaoshoufenxixitong').css("top", "107px");
              $('.shuju-topmenu-panel').css('height', '63px');
              $('ul:not(.wheel-scroll)').removeClass('display-flex').removeClass('flex-wrap-wrap').addClass('scrolling-wrapper');
            } else {
              $('div.tabs-top div.shuju-topmenu-panel').removeClass('fixed-header');
              $('ion-content.xiaoshoufenxixitong').css("top", "170px");
              $('.shuju-topmenu-panel').css('height', '126px');
              $('ul:not(.wheel-scroll)').removeClass('scrolling-wrapper').addClass('display-flex').addClass('flex-wrap-wrap');
            }
          }
        });
      });

      $('ion-content.zhongduandashuju').css("top", $scope.isJingxiaoshang() ? "170px" : '107px');
      $('.shuju-topmenu-panel').css('height', $scope.isJingxiaoshang() ? '126px' : '63px');
      
      $scope.showTip1 = false;
      $scope.showTip2 = false;
      $scope.showTip3_1 = false;
      $scope.showTip3_2 = false;
      $scope.showTip4 = false;

      $scope.toggleTip1 = function() {
        $scope.showTip1 = !$scope.showTip1;
      }

      $scope.toggleTip2 = function() {
        $scope.showTip2 = !$scope.showTip2;
      }

      $scope.toggleTip3_1 = function() {
        $scope.showTip3_1 = !$scope.showTip3_1;
      }

      $scope.toggleTip3_2 = function() {
        $scope.showTip3_2 = !$scope.showTip3_2;
      }

      $scope.toggleTip4 = function() {
        $scope.showTip4 = !$scope.showTip4;
      }

    });
})();

