(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('YixiangkehuGenjinController', function($rootScope, $scope, $ionicPopup, fenxiService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      $scope.pageNumber = 1;
      $scope.pageSize = 100;

      $scope.loadData = () => {
        fenxiService.queryNewCustomerTrack()
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.newCustomerTrackList = res.data.data;
            $scope.tips = res.data.tips;
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();            	
        },
        function(err){
          $scope.refreshComplete();            		
        });
      }

      $scope.doRefresh = function () {
        $scope.newCustomerTrackList = [];
        $scope.loadData();
      };      
      $scope.showLoading();
      $scope.doRefresh();

    });
})();

