(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('ShijianXinzengController', function($scope, $state, ionicMaterialInk, shijianService, $ionicPopup) {

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
      
      $scope.data = {
        fsaleevent: '',
        fbegdate: null,
        fenddate: null,
      };

      $scope.register = function() {
        if (!$scope.data.fsaleevent) {
          $scope.showToast({title: "请输入事件标题！"});
          return;
        }
        if (!$scope.data.fbegdate) {
          $scope.showToast({title: "请输入执行日期！"});
          return;
        }
        if (!$scope.data.fenddate) {
          $scope.showToast({title: "请输入完成日期！"});
          return;
        }
        
        $scope.data.datalog = [
          {
              "ftype": "新增",
              "flog": "新增记录",
          }
        ]
        $scope.showLoading();
				shijianService.querySaleEventInsertOrModify(0, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });

      }
      
      new Rolldate({
        el: '#fbegdate',
        format: 'YYYY-MM-DD',
        value: $scope.data.fbegdate,
        confirm: function(date) {
          $scope.data.fbegdate = date;
          $scope.$apply($scope.data);
        },
      });

      new Rolldate({
        el: '#fenddate',
        format: 'YYYY-MM-DD',
        value: $scope.data.fenddate,
        confirm: function(date) {
          $scope.data.fenddate = date;
          $scope.$apply($scope.data);
        },
      });

		});
})();

