/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('XiaoshouJiluXinzengController', function($scope, $state, ionicMaterialInk, xiaoshouJiluService, $ionicPopup) {

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.data = {
        famount: '',
        fagents_purchaseid: 0,
        fdate: null,
        tagentsid: '',
      };

      $scope.showLoading();

      xiaoshouJiluService.queryAgentList()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.agentList = res.data.data;
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });


      $scope.register = function() {
        $scope.showLoading();
        $scope.data.datalog = [
          {
              "ftype": "新增",
              "flog": "新增记录",
          }
        ]
				xiaoshouJiluService.saleInsertOrModify(0, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      new Rolldate({
        el: '#fdate',
        format: 'YYYY-MM',
        value: $scope.data.fdate,
        confirm: function(date) {
          $scope.data.fdate = date;
          $scope.$apply($scope.data);
        },
      });

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentSelectPanel = function() {
        $scope.selectModel = $scope.agentList;
        $scope.selectKeyField = "tagentsid";
        $scope.selectValueField = "fagentname";
        $scope.selectModelName = "tagentsid";
        $scope.selected = $scope.data.tagentsid;

        $scope.showSelectPanel();
      }

		});
})();

