(function(){

	"use strict";
	angular.module('starter.services')

	.service('xinxiaoxiService', function (apiService, userService) {
		let self = this;

    // 消息查询
    self.queryMessage = function(fromdb, pageNumber, pageSize, ftype) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "system.message.Message",
					"method": "queryMessage",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"ftype": ftype,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 消息阅读
    self.readMessage = function(messageId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "system.message.Message",
					"method": "readMessage",
					"content": {
						"userid": userService.getUserId(),
						"tmessageid": messageId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

	})

})();
