/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('SelectBussinesstripController', function($scope, $state, ionicMaterialInk, biaozhunService, $ionicActionSheet, multimediaService, $ionicPopup) {

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
      
      $scope.$on('$destroy', function() {
        $scope.clearKeyword()
      });

      // localStorage.setItem('businesstrip', '');

      $scope.selectBusinessTrip = function(businessTrip) {
        localStorage.setItem('businesstrip', JSON.stringify(businessTrip));
        $scope.goBack();
      }

      $scope.businessTripListPageNumber = 1;
      $scope.businessTripListPageSize = 10;
      $scope.loadBusinessTripData = function() {
        $scope.showLoading();
        biaozhunService.queryBusinessTripList(
          $scope.businessTripListPageNumber, $scope.businessTripListPageSize, $scope.keyword
        )
        .then(function(res){
          if (res.data.code === 1) {
            $scope.businessTripList = $scope.businessTripList.concat(res.data.data);
            $scope.businessTripListPageTotal = res.data.pageTotal;
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.doBusinessTripListRefresh = function () {
        $scope.businessTripListPageNumber = 1
        $scope.businessTripList = [];
        $scope.loadBusinessTripData();
      };
      $scope.showLoading();
      $scope.doBusinessTripListRefresh();
  
      $scope.loadMoreBusinessTripList = function() {
        $scope.businessTripListPageNumber += 1;
        $scope.loadBusinessTripData();  
      }

      $scope.$on('refresh', function(ev) {
        $scope.doBusinessTripListRefresh();
      });

      $scope.isShowBusinessTripSelector = false;

      // get keywords
      $scope.keywords = $scope.loadKeywords();
		});
})();

