// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ionic.closePopup', 'starter.controllers', 'starter.services', 'ionic-material', 'ion-floating-menu', 'ionic-autocomplete', 'angular-carousel', 'angular-svg-round-progressbar'])

.run(function($ionicPlatform, $state, $ionicHistory, $window, userService) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs).
    // The reason we default this to hidden is that native apps don't usually show an accessory bar, at
    // least on iOS. It's a dead giveaway that an app is using a Web View. However, it's sometimes
    // useful especially with forms, though we would prefer giving the user a little more room
    // to interact with the app.
    // if (window.cordova && window.Keyboard) {
    //   window.Keyboard.hideKeyboardAccessoryBar(true);
    // }

    // if (window.StatusBar) {
    //   // Set the statusbar to use the default style, tweak this to
    //   // remove the status bar on iOS or change it to use white instead of dark colors.
    //   StatusBar.styleDefault();
    // }
    
    // $ionicPlatform.registerBackButtonAction(function (event) {
    //   if($state.current.name=="app.dash"){
    //     userService.logout();
    
    //     $ionicHistory.nextViewOptions({
    //       disableBack: true,
    //       historyRoot: true,
    //       disableAnimate: true
    //     });
    
    //     $ionicHistory.clearCache();
    //     $ionicHistory.clearHistory();
    //     $state.go('app.login', {}, {reload: true});
    //   } else
    //     $window.history.go(-1);
    // }, 100);

    if (window.AppUpdate) {
      // Check version
      /*
        var versionCode = AppVersion.build
        console.log(versionCode)
      */
      window.AppUpdate.checkAppUpdate(res => {
        // console.log(res)
      }, err => {
        // console.error (err)
      }, UPDATE_URL);
      
    }
  });
});
