(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('JingxiaoshangDanganController', function($rootScope, $scope, $ionicPopup, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 100;

      $scope.loadData = () => {
        qiyeShujuService.agentList($scope.pageNumber, $scope.pageSize)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.agentList = $scope.agentList.concat(res.data.data);
            $scope.pageTotal = res.data.pageTotal;
            $scope.agentList.forEach(function(item) {
              if (item.fprovince && item.fcity && item.fcounty
                  && !isNaN(Number(item.fprovince))
                  && !isNaN(Number(item.fcity))
                  && !isNaN(Number(item.fcounty))) {
                item.fcounty = $scope.locationList[item.fcity][item.fcounty];
                item.fcity = $scope.locationList[item.fprovince][item.fcity];
                item.fprovince = $scope.locationList['86'][item.fprovince];
              }
            })
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err) {
          $scope.refreshComplete();
        });
      }

      $scope.doRefresh = function () {
        $scope.showLoading();
        $scope.pageNumber = 1
        $scope.totalAmount = 0;
        $scope.agentList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      $scope.$on('refresh', function(ev) {
        $scope.doRefresh();
      });
    });
})();

