(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('FeiyongXinzengController', function($scope, $state, ionicMaterialInk, $ionicPopup, feiyongService ) {

			ionicMaterialInk.displayEffect();
			$scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

			var d = new Date();

			$scope.data = {
				fdate: getDateString(d),
				costlist:[
					{ fcostname: '货运', ftype: "主项"},//, famount: 0
					{ fcostname: '客勤', ftype: "主项"},
					{ fcostname: '活动', ftype: "主项"},
					{ fcostname: '赠品', ftype: "杂项"},
					{ fcostname: '其它费用', ftype: "杂项"},
					{ fcostname: '房租', ftype: "杂项"},
					{ fcostname: '水电', ftype: "杂项"},
					{ fcostname: '薪资提成', ftype: "杂项"},
					{ fcostname: '进货额', ftype: "主项"}
				]
			};

			$scope.register = function() {
				if (!$scope.data.fdate) {
					$scope.showToast({title: "请输入日期!"});
					return;
				}

				var sum = 0;
				for (var i = 0; i < $scope.data.costlist.length; i++){
					if (!$scope.data.costlist[i].famount)
						$scope.data.costlist[i].famount = 0;
					sum += $scope.data.costlist[i].famount;
				}

				if (sum == 0) {
					$scope.showToast({title: "请输入至少一个项目的金额!"});
					return;
				}
				$scope.data.datalog = [
          {
              "ftype": "新增",
              "flog": "新增记录",
          }
        ]
				feiyongService.queryCostInsertOrModify(0, $scope.data.fdate, $scope.data.costlist, $scope.data.datalog)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
				    $scope.goBack();
          } else
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
			}

			new Rolldate({
				el: '#fdate',
				format: 'YYYY-MM-DD',
				value: $scope.data.fdate,
        confirm: function(date) {
					$scope.data.fdate = date;
					$scope.$apply($scope.data);
        },
			});

		});
})();
