(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('RenwuZhongxinController', function($scope, $state, ionicMaterialInk, $ionicPopup, gerenService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });

      $scope.taskList = [
        {
          name: '每日签到',
          score: '行动力+10',
          target: 'app.jinriqiandao',
          visible: true,
          checked: false
        },
        {
          name: '阅读通告',
          score: '行动力+5',
          target: 'app.tonggaoliebiao',
          visible: !$scope.isAgentRole(),
          checked: false
        },
        {
          name: '通告评分',
          score: '行动力+10',
          target: 'app.tonggaoliebiao',
          visible: !$scope.isAgentRole(),
          checked: false
        },
        {
          name: '下载通告附件',
          score: '行动力+5',
          target: 'app.tonggaoliebiao',
          visible: !$scope.isAgentRole(),
          checked: false
        },
        {
          name: '下载营销智库',
          score: '行动力+5',
          target: 'app.sucailiebiao',
          visible: !$scope.isAgentRole(),
          checked: false
        },
        {
          name: '意向客户录入',
          score: '行动力+5',
          target: 'app.jiedaixinzeng',
          visible: $scope.isJingxiaoshang() && ($scope.getIsProfessionalVersion() || $scope.isAgentRole()),
          checked: false
        },
        {
          name: '销售录入',
          score: '行动力+5',
          target: 'app.xiaoshouxinzeng',
          visible: $scope.isJingxiaoshang() && ($scope.getIsProfessionalVersion() || $scope.isAgentRole()),
          checked: false
        },
        {
          name: '费用录入',
          score: '行动力+5',
          target: 'app.feiyongxinzeng',
          visible: $scope.isJingxiaoshang() && $scope.getIsProfessionalVersion() && !$scope.isAgentRole(),
          checked: false
        },
        {
          name: '事件录入',
          score: '行动力+5',
          target: 'app.shijianxinzeng',
          visible: $scope.isJingxiaoshang() && $scope.getIsProfessionalVersion() && !$scope.isAgentRole(),
          checked: false
        },
        {
          name: '智库分享',
          score: '行动力+5',
          target: 'app.sucaixinzeng',
          visible: $scope.isJingxiaoshang() && $scope.getIsProfessionalVersion() && !$scope.isAgentRole(),
          checked: false
        },
        {
          name: '标准工作录入',
          score: '行动力+5',
          target: 'app.biaozhunxinzeng',
          visible: !$scope.isJingxiaoshang() && !$scope.getIsBasicVersion(),
          checked: false
        },
        {
          name: '自选工作录入',
          score: '行动力+5',
          target: 'app.zixuanxinzeng',
          visible: !$scope.isJingxiaoshang() && !$scope.getIsBasicVersion(),
          checked: false
        },
        {
          name: '行程评优',
          score: '行动力+5',
          target: 'app.chuchaxinzeng',
          visible: !$scope.isJingxiaoshang() && !$scope.getIsBasicVersion(),
          checked: false
        },
        {
          name: '销售录入',
          score: '行动力+5',
          target: 'app.xiaoshoujiluxinzeng',
          visible: !$scope.isJingxiaoshang() && $scope.getIsProfessionalVersion(),
          checked: false
        },
        {
          name: '店铺录入',
          score: '行动力+5',
          target: 'app.dianpuxinzeng',
          visible: !$scope.isJingxiaoshang() && !$scope.getIsBasicVersion(),
          checked: false
        },
      ]

      gerenService.queryXingdongli()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.xingdongli = res.data.data;
        } else{
          
        }
      },
      function(err){
      });

      gerenService.queryRenwuWancheng()
      .then(function(res){
        if (res.data.code === 1) {
          res.data.data.forEach(element => {
            $scope.taskList.forEach(task => {
              if (task.name == element.ftaskname)
                task.checked = true
            })
          });
        }
      });

      $scope.getIsChecked = (v) => {
        return ($scope.data.indexOf($scope.formatDate(v)) != -1);
      }

      $scope.checked = false;
      gerenService.querySigninLog()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data;
          $scope.checked = $scope.getIsChecked(new Date());
        } else{
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      $(function() {
        // $('.tab-nav.tabs > a')[1].style.display = 'block';
        // $('.tab-nav.tabs > a')[2].style.display = 'none';
        // $('.tab-nav.tabs > a')[3].style.display = 'none';
        // $('.tab-nav.tabs > a')[4].style.display = 'none';
        // $('.tab-nav.tabs > a')[5].style.display = 'none';
        // $('#xiaoxiCount')[0].style.display = 'none';
      });
		});
})();
