(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('XingdongliController', function($scope, $state, $stateParams, ionicMaterialInk, $ionicPopup, gerenService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 20;

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });

      $scope.loadData = () => {
        gerenService.queryXingdongliLog(
          $scope.pageNumber, // pageNumber
          $scope.pageSize, // pageSize
          $scope.xingdongli.tactionscoreid, // tactionScoreId
          '个人', // ftypemx
        )
        .then(function(res){
          if (res.data.code === 1) {
            $scope.dataList = $scope.dataList.concat(res.data.data);
            $scope.pageTotal = res.data.pageTotal;
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.doRefresh = function () {
        $scope.pageNumber = 1;
        $scope.dataList = [];
        $scope.loadData();
      };

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      $scope.showLoading();
      gerenService.queryXingdongli()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.xingdongli = res.data.data;

          $scope.doRefresh();
        } else{
          
        }
      },
      function(err){
      });
      
      $(function() {
        // $('.tab-nav.tabs > a')[1].style.display = 'block';
        // $('.tab-nav.tabs > a')[2].style.display = 'none';
        // $('.tab-nav.tabs > a')[3].style.display = 'none';
        // $('.tab-nav.tabs > a')[4].style.display = 'none';
        // $('.tab-nav.tabs > a')[5].style.display = 'none';
        // $('#xiaoxiCount')[0].style.display = 'none';
      });
		});
})();

