(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('ZhanghuXinzengController', function($scope, $state, ionicMaterialInk, $ionicPopup, gerenService) {

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.data = {
        tstoreid:	'',
        tenterprise_userid:	0,
        fname:	null,
        logintimes:	0,
        fphonenumber:	"",
        subusers:	[],
        fshortcode:	"",
        fstorename:	null,
        frole:	"",
      }

      gerenService.selectStore()
      .then(function(res){
        $scope.stores = res.data.data;
      },
      function(err){
      });

      $scope.register = function() {
        // if (!checkPhone($scope.data.fphonenumber)){
        //   $scope.showToast({title: '手机号码有误，请重填'});
        //   return;
        // }

        $scope.showLoading();

        // $scope.data.subusers = $scope.tag
        gerenService.updateUserMsg(0, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.isShowTags = false
      
      $scope.showTags = function() {
        $('#tagSelector').css('height', '200px');
        $scope.isShowTags = true;
      }

      $scope.hideTags = function() {
        $scope.isShowTags = false;
      }

      $scope.tag = []
      $scope.selectTag = function(tag) {
        tag.selected = tag.selected == true ? false : true

        $scope.tag = []

        let tagTxt = ''
        for (let i in $scope.dataList) {
          if ($scope.dataList[i].selected == true)
          {
            if ($scope.dataList[i].fname)
              tagTxt = `${tagTxt}, ${$scope.dataList[i].fname}`
            $scope.tag.push({
              fsubid: $scope.dataList[i].tenterprise_userid
            })
          }
        }

        $("#tag-selector").val(tagTxt.substr(1))
      }
		});
})();

