(function(){
	'use strict';
	angular.module('starter.controllers')
		.controller('RegisterAgentController', function($scope, gerenService, $ionicPopup, $state) {
      $scope.$parent.showHeader();
			$scope.hideTabBar();

      $scope.data = {
        fname: '',
        fphonenumber: $state.params.phone,
        fagentname: '',
        fprovince: '',
        fcity: '',
        fcounty: '',
        faddress: '',
        fsex: '',
        fbirthdate: '',
        femail: '',
      };

      $scope.modify = function() {
        $scope.showLoading();
        gerenService.registerAgents($scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            // $scope.showToast({title: '创建成功！'})
            res.data.account_list.forEach(element => {
              if (element.fagentname == $scope.data.fagentname) {
                $scope.selectUser(element);
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $(function() {
        new Rollarea({
          el: '#dizhi',
          format: 'province-city-county',
          value: {'fprovince': $scope.data.fprovince, 'fcity': $scope.data.fcity, 'fcounty': $scope.data.fcounty},
          confirm: function(area) {
            $scope.data.fprovince = area.fprovince;
            $scope.data.fcity = area.fcity;
            $scope.data.fcounty = area.fcounty;
          },
        });
      });

      

    });
})();

