/* global angular, document, window, LANG */
(function(){
	"use strict";

	angular.module('starter.controllers')
		.controller('SelectUserController', function($scope, $ionicPopup, ionicMaterialInk, $ionicHistory, $state, userService) {
			ionicMaterialInk.displayEffect();
			$scope.showHeader();
			$scope.hideTabBar();
			
			$scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = false;
      });
			$scope.accountList = JSON.parse(localStorage.getItem('accounts'));

			$scope.select = function(item) {
				$scope.selectUser(item);
			};

			$scope.confirmBack = () => {
				let backView = $ionicHistory.backView()
				if (backView && (backView.stateId == 'app.dash' || backView.stateName == 'app.dash')) {
					$scope.goBack()
					return
				}
				$ionicPopup.show({
					subTitle: '<div><span class="popup-content">是否退出登录？</span></div>',
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
						$scope.goBack();
          }
				});
			}

		});
})();
