/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('TibaoLiebiaoController', function($scope, $ionicPopup, $ionicPopover, $state, $stateParams, multimediaService, tibaoService) {
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

			$scope.pageNumber = 1;
			$scope.pageSize = 20;
			$scope.pageNumber1 = 1;
			$scope.pageSize1 = 20;

			$scope.navIndex = localStorage.getItem('tibaoliebiao.navindex') ? localStorage.getItem('tibaoliebiao.navindex') : 0;

			$scope.showSlide = function (num) {
				$scope.navIndex = num;
				localStorage.setItem('tibaoliebiao.navindex', num);
        $scope.$broadcast('scroll.refreshComplete');
			};
			
			$scope.loadData = () => {
        tibaoService.querySubmiteditModelList(
          $scope.pageNumber, // pageNumber
          $scope.pageSize, // pageSize
        )
				.then(function(res){
					if (res.data.code === 1) {
						$scope.dataList = $scope.dataList.concat(res.data.data);
						$scope.pageTotal = res.data.pageTotal;
					} else{
						//$ionicPopup.alert({
						//	title: res.data.msg
						//});
					}
					$scope.refreshComplete();
				},
				function(err){
					$scope.refreshComplete();
				});
      }

      $scope.showLoading();
			$scope.doRefresh = function () {
        $scope.pageNumber = 1;
        $scope.dataList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

			if (!$scope.isJingxiaoshang()) {
				$scope.loadMore1 = function() {
					$scope.pageNumber1 += 1;
					$scope.loadData1();
				}
				
				$scope.loadData1 = () => {
					tibaoService.querySubSubmiteditModelList(
						$scope.pageNumber1, // pageNumber
						$scope.pageSize1, // pageSize
					)
					.then(function(res){
						if (res.data.code === 1) {
							$scope.dataList1 = $scope.dataList1.concat(res.data.data);
							$scope.pageTotal1 = res.data.pageTotal1;
						} else{
							//$ionicPopup.alert({
							//	title: res.data.msg
							//});
						}
						$scope.refreshComplete();
					},
					function(err){
						$scope.refreshComplete();
					});
				}
				
				$scope.doRefresh1 = function () {
					$scope.pageNumber1 = 1;
					$scope.dataList1 = [];
					$scope.loadData1();
				};
				$scope.doRefresh1();

				$scope.loadMore1 = function() {
					$scope.pageNumber1 += 1;
					$scope.loadData1();
				}
			}
		});
})();

