(function(){

	"use strict";
	angular.module('starter.services')

	.service('tibaoService', function (apiService, userService) {
		let self = this;

    // 提报列表查询
    self.querySubmiteditModelList = function(pageNumber, pageSize) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.submitedit.submitedit" : "salerclient.mainpage.submitedit.submitedit",
					"method": "query_submiteditmodelList",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"pageNumber": pageNumber,
            "pageSize": pageSize,
					}
				}
			};

			return apiService.makeRequest(request);
    };

    // 提报主界面查询
    self.querySubmiteditModelMain = function(submiteditModelId) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.submitedit.submitedit" : "salerclient.mainpage.submitedit.submitedit",
					"method": "query_submiteditmodelMain",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"tsubmiteditmodelid": submiteditModelId,
					}
				}
			};

			return apiService.makeRequest(request);
    };

    // 提报保存
    self.querySaveedit = function(submiteditModelId, fcontent) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.submitedit.submitedit" : "salerclient.mainpage.submitedit.submitedit",
					"method": "saveedit",
					"content": {
						"userid": userService.getUserId(),
            "tsubmiteditmodelid": submiteditModelId,
            "fcontent": fcontent,
					}
				}
			};

			return apiService.makeRequest(request);
    };

    // 提报提交
    self.querySubmitedit = function(submiteditModelId, fcontent) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.submitedit.submitedit" : "salerclient.mainpage.submitedit.submitedit",
					"method": "submitedit",
					"content": {
						"userid": userService.getUserId(),
            "tsubmiteditmodelid": submiteditModelId,
            "fcontent": fcontent,
					}
				}
			};

			return apiService.makeRequest(request);
		};
		
		// 提报管理列表查询
    self.querySubSubmiteditModelList = function(pageNumber, pageSize) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.submitedit.submitedit" : "salerclient.mainpage.submitedit.submitedit",
					"method": "query_subsubmiteditmodelList",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"pageNumber": pageNumber,
            "pageSize": pageSize,
					}
				}
			};

			return apiService.makeRequest(request);
    };

    // 提报管理主界面查询
    self.querySubSubmiteditModelMain = function(submiteditModelId) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.submitedit.submitedit" : "salerclient.mainpage.submitedit.submitedit",
					"method": "query_subsubmiteditmodelMain",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"tsubmiteditmodelid": submiteditModelId,
					}
				}
			};

			return apiService.makeRequest(request);
    };

	})

})();
