(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('TibaoXiangqingController', function($scope, $rootScope, $stateParams, multimediaService, $ionicPopup, tibaoService) {
      $scope.showHeader();
      $scope.hideTabBar();
      $rootScope.isDownloading = -1

      const tibaoId = $stateParams.tibaoid;
      const type = $stateParams.type;
      $scope.type = $stateParams.type;
      $scope.title = type == 0 ? "提报详情" : "提报管理"
      $scope.webFujian = []
      $scope.mobileFujian = []

      $scope.loadData = () => {
        if (type == 0) {
          tibaoService.querySubmiteditModelMain(
            tibaoId,
          )
          .then(function(res){
            if (res.data.code === 1) {
              $scope.data = res.data.data;
              if (res.data.data[0].tsubmiteditid)
                multimediaService.getImageList(res.data.data[0].tsubmiteditid, 'tsubmitedit').then(res => {
                  $scope.mobileFujian = res.data.data
              });
            } else{
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
            $scope.refreshComplete();
          },
          function(err){
            $scope.refreshComplete();
          });
        } else {
          tibaoService.querySubSubmiteditModelMain(
            tibaoId,
          )
          .then(function(res){
            if (res.data.code === 1) {
              $scope.data = res.data.data;
              if (res.data.data[0].tsubmiteditid)
                multimediaService.getImageList(res.data.data[0].tsubmiteditid, 'tsubmitedit').then(res => {
                  $scope.mobileFujian = res.data.data
              });
            } else{
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
            $scope.refreshComplete();
          },
          function(err){
            $scope.refreshComplete();
          });         
        }
      }

      multimediaService.getImageList(tibaoId, 'tsubmiteditmodel').then(res => {
        $scope.webFujian = res.data.data
      });
      
      $scope.showLoading();
      $scope.loadData();
      
		});
})();

