(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('TonggaoLiebiaoController', function($scope, $state, ionicMaterialInk, $ionicPopup, tonggaoService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 20;
      $scope.condition = '';

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });
      
      $scope.loadData = () => {
        tonggaoService.queryNoticeList(
          $scope.pageNumber, // pageNumber
          $scope.pageSize, // pageSize
          $scope.condition, // condition
        )
          .then(function(res){
            // console.log(res);
            if (res.data.code === 1) {
              $scope.dataList = $scope.dataList.concat(res.data.data);
              $scope.pageTotal = res.data.pageTotal;
            } else{
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
            $scope.refreshComplete();
          },
          function(err){
            $scope.refreshComplete();
          });
      }

      $scope.showLoading();
			$scope.doRefresh = function () {
        $scope.pageNumber = 1;
        $scope.dataList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }
		});
})();

