(function(){

	"use strict";
	angular.module('starter.services')

	.service('tousuService', function (apiService, userService) {
		let self = this;

    // 投诉创建及提交
    self.insertComplaint = function(ftype, ftitle, fcontent) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.complaint.complaint" : "salerclient.mainpage.complaint.complaint",
					"method": "insert",
					"content": {
            "userid": userService.getUserId(),
            "ftype": ftype,
            "ftitle": ftitle,
            "fcontent": fcontent
					}
				}
			};

			return apiService.makeRequest(request);
		};
		
		// 投诉版块
		self.queryTypeList = function() {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "webclient.system.complaint",
					"method": "query_typeList",
					"content": {
						"getdatafromdbanyway": true,
            "userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

	})

})();
