(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('ZhifuLiebiaoController', function($scope, $state, $stateParams, ionicMaterialInk, $ionicPopup, userService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 20;

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });

      userService.queryAccountBalance().then(res => {
        if (res.data.code == 1 && res.data.data[0]) {
          $scope.balanceData = res.data.data[0]
        }
      })

      $scope.loadData = () => {
        userService.queryAccountdetails().then(function(res){
          if (res.data.code === 1) {
            $scope.dataList = $scope.dataList.concat(res.data.data);
            $scope.pageTotal = res.data.pageTotal;
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.doRefresh = function () {
        $scope.pageNumber = 1;
        $scope.dataList = [];
        $scope.loadData();
      };

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      $scope.showLoading();
      $scope.doRefresh()
		});
})();

